<?php
/**
 * Content wrappers
 *
 * This template can be overridden by copying it to yourtheme/woocommerce/global/wrapper-start.php.
 *
 * HOWEVER, on occasion WooCommerce will need to update template files and you
 * (the theme developer) will need to copy the new files to your theme to
 * maintain compatibility. We try to do this as little as possible, but it does
 * happen. When this occurs the version of the template file will be bumped and
 * the readme will list any important changes.
 *
 * @see 	    https://docs.woocommerce.com/document/template-structure/
 * @author 		WooThemes
 * @package 	WooCommerce/Templates
 * @version     3.3.0
 */

if ( ! defined( 'ABSPATH' ) ) {
	exit; // Exit if accessed directly
}

$template = wc_get_theme_slug_for_templates();

switch ( $template ) {
	case 'twentyten' :
		echo '<div id="container"><div id="content" role="main">';
		break;
	case 'twentyeleven' :
		echo '<div id="primary"><div id="content" role="main" class="twentyeleven">';
		break;
	case 'twentytwelve' :
		echo '<div id="primary" class="site-content"><div id="content" role="main" class="twentytwelve">';
		break;
	case 'twentythirteen' :
		echo '<div id="primary" class="site-content"><div id="content" role="main" class="entry-content twentythirteen">';
		break;
	case 'twentyfourteen' :
		echo '<div id="primary" class="content-area"><div id="content" role="main" class="site-content twentyfourteen"><div class="tfwc">';
		break;
	case 'twentyfifteen' :
		echo '<div id="primary" role="main" class="content-area twentyfifteen"><div id="main" class="site-main t15wc">';
		break;
	case 'twentysixteen' :
		echo '<div id="primary" class="content-area twentysixteen"><main id="main" class="site-main" role="main">';
		break;
	default :
		
		if( is_product() ) {

			// It is a single product page.
			$woo_layout = esc_attr( get_theme_mod( 'woo_singleprod_layout', 'fullw' ) );
			if( $woo_layout == 'rights' ) {
				$woo_pre_cls = 'col-md-8';
			} elseif( $woo_layout == 'lefts' ) {
				$woo_pre_cls = 'col-md-8 layoutleftsidebar';
			} else {
				$woo_pre_cls = 'col-md-12';
			}
			echo '<div class="' . $woo_pre_cls . '"> <div class="left-content" > <div class="single-posst" >';

		} else {

			$woo_layout = esc_attr( get_theme_mod( 'woo_layout', 'fullw' ) );
			if( $woo_layout == 'rights' ) {
				$woo_pre_cls = 'col-md-8';
			} elseif( $woo_layout == 'lefts' ) {
				$woo_pre_cls = 'col-md-8 layoutleftsidebar';
			} else {
				$woo_pre_cls = 'col-md-12';
			}
			echo '<div class="' . $woo_pre_cls . '"> <div class="left-content" > <div class="single-posst" >';

		}

		break;
}
