<?php
/**
 * Checkout Form
 *
 * This template can be overridden by copying it to yourtheme/woocommerce/checkout/form-checkout.php.
 *
 * HOWEVER, on occasion WooCommerce will need to update template files and you
 * (the theme developer) will need to copy the new files to your theme to
 * maintain compatibility. We try to do this as little as possible, but it does
 * happen. When this occurs the version of the template file will be bumped and
 * the readme will list any important changes.
 *
 * @see 	    https://docs.woocommerce.com/document/template-structure/
 * @author 		WooThemes
 * @package 	WooCommerce/Templates
 * @version     5.3.0
 */

if ( ! defined( 'ABSPATH' ) ) {
	exit;
}

wc_print_notices();
echo '<div class="row">';
do_action( 'woocommerce_before_checkout_form', $checkout );
echo '</div>';
// If checkout registration is disabled and not logged in, the user cannot checkout
if ( ! $checkout->is_registration_enabled() && $checkout->is_registration_required() && ! is_user_logged_in() ) {
	echo apply_filters( 'woocommerce_checkout_must_be_logged_in_message', esc_html__( 'You must be logged in to checkout.', 'bc-shop' ) );
	return;
}

?>
<div class="clearfix"></div>

<form name="checkout" method="post" class="checkout woocommerce-checkout" action="<?php echo esc_url( wc_get_checkout_url() ); ?>" enctype="multipart/form-data">
<div class="row">
	<?php if ( $checkout->get_checkout_fields() ) : ?>

		<?php do_action( 'woocommerce_checkout_before_customer_details' ); ?>

		<div class="col-xs-12 col-sm-12 col-md-7" id="customer_details">
        
            <div class="checkout-billing">
                <?php do_action( 'woocommerce_checkout_billing' ); ?>
            </div>

            <div class="checkout-shipping">
                <?php do_action( 'woocommerce_checkout_shipping' ); ?>
            </div>
            
		</div>

		<?php do_action( 'woocommerce_checkout_after_customer_details' ); ?>

	<?php endif; ?>

	<div class="col-xs-12 col-sm-12 col-md-5">

		<?php do_action( 'woocommerce_checkout_before_order_review' ); ?>
    	<h3 id="order_review_heading"><?php esc_attr_e( 'Your order', 'bc-shop' ); ?></h3>
        <div id="order_review" class="woocommerce-checkout-review-order">
            <?php do_action( 'woocommerce_checkout_order_review' ); ?>
        </div>
        
    </div>

	<?php do_action( 'woocommerce_checkout_after_order_review' ); ?>
</div>
</form>

<?php do_action( 'woocommerce_after_checkout_form', $checkout ); ?>
